require 'bender/classes/Plugin'
require 'bender/classes/Models/Webserver/SMTPLogin'

$pluginClass = :ICMail

class ICMail < ICPlugin
  def initialize(*args)
    super

    conn = baseConfig.get_string_array('/ICSystemConf/ServicesDatabase')
    conn = {adapter: 'mysql2'}.merge(conn[0])
    Webserver::SMTPLogin.establish_connection conn
  end

  def provision(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
    settings(host, service, env)
  end

  def update(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
    settings(host, service, env)
  end

  def maintain(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
  end

  def deactivate(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]

    deconfigureAccount(host, service, env)
  end

  def activate(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]

    configureAccount(host, service, env)
  end

  def prepare(args)
    service = args[:service]
    action = args[:action]
    env = args[:env]
  end

  def cleanup(args)
    service = args[:service]
    action = args[:action]
    env = args[:env]
  end

  protected

  def settings(host, service, env)
    #TODO

    if host.smtp && env[:env_vars]['SMTP_SERVER'].blank?
      env[:env_vars]['SMTP_SERVER']   = host.smtp.smpt_server
      if env[:env_vars]['SMTP_SERVER']
        env[:env_vars]['SMTP_PORT']     = host.smtp.smtp_port
        env[:env_vars]['SMTP_TLS']      = host.smtp.smtp_tls
        env[:env_vars]['SMTP_STARTTLS'] = host.smtp.smtp_starttls
        env[:env_vars]['SMTP_DOMAIN'] = host.smtp.domain
      else
        env[:env_vars]['SMTP_SERVER']   = service.mySvcConf('/Services/SMTP/Host')
        env[:env_vars]['SMTP_PORT']     = service.mySvcConf('/Services/SMTP/Port')
        env[:env_vars]['SMTP_TLS']      = service.mySvcConf('/Services/SMTP/TLS').to_s == 'true'
        env[:env_vars]['SMTP_STARTTLS'] = service.mySvcConf('/Services/SMTP/STARTTLS').to_s == 'true'
        env[:env_vars]['SMTP_DOMAIN']   = service.mySvcConf('/Services/SMTP/Domain')
      end
      env[:env_vars]['SMTP_USERNAME'] = host.smtp.username
      env[:env_vars]['SMTP_PASSWORD'] = host.smtp.password
    end
  end

  def deconfigureAccount(host, service, env)
    if host.smtp
      Webserver::SMTPLogin.where(username: host.smtp.username).first.try(&:destroy!)
    end
  end

  def configureAccount(host, service, env)
    if host.smtp
      record = Webserver::SMTPLogin.find_or_initialize_by(username: host.smtp.username) if host.smtp
      record.password = host.smtp.password
      record.save!
    end
  end
end
