require 'bender/classes/Plugin'
require 'bender/tools/SelfSignedCert'
require 'mail'

$pluginClass = :SSL

class SSL < ICPlugin
  include SelfSignedCert
  def provision(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]

    sslCerts(host, service, env)
  end

  def update(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]

    sslCerts(host, service, env)
  end

  def maintain(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
  end

  def deactivate(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
  end

  def activate(args)
    host = args[:host]
    service = args[:service]
    env = args[:env]
  end

  def prepare(args)
    service = args[:service]
    action = args[:action]
    env = args[:env]
  end
  
  def cleanup(args)
    service = args[:service]
    action = args[:action]
    env = args[:env]
  end

  protected

  def sslCerts(host, service, env)
    if host.ssl.enabled
      env[:settings][:ssl] ||= {}

      path = certsPath(host, service, env)
      if host.ssl.certs && host.ssl.certs.any?
        host.ssl.certs.each.with_index do | crt, idx |
          if crt.crt.present? && crt.key.present?
            env[:settings][:ssl][:certs] ||= {}
            log.debug "  + Write certificate for domains #{crt.domains.join(', ')}"
            service.write(File.join(path, "#{crt.crt_id}.pem"), crt.crt)
            service.write(File.join(path, "#{crt.crt_id}.key"), crt.key)
            env[:settings][:ssl][:certs][crt.crt_id] = "#{crt.domains.join(',')}"
          end
        end
      end
    end
  end

  def certsPath(host, service, env)
    basePath = service.baseConfig.get_entry('/ICSystemConf/BaseDir')
    sslPath = File.join(basePath, service.mySvcConf('/System/CertsRoot'),
      host.service.name)
  end
end