module SelfSignedCert
  def generateCert(domains)
    key = OpenSSL::PKey::RSA.new 2048
    cert = OpenSSL::X509::Certificate.new
    cert.version = 2
    cert.serial = SecureRandom.hex(10).to_i(16)
    cert.subject = subject(domains)
    cert.issuer = cert.subject
    cert.public_key = key.public_key
    cert.not_before = Time.now
    cert.not_after = cert.not_before + 2 * 365 * 24 * 60 * 60
    ef = OpenSSL::X509::ExtensionFactory.new
    ef.subject_certificate = cert
    cert.add_extension(ef.create_extension("subjectAltName","DNS:#{domains.join(',DNS:')}",false))
    cert.sign(key, OpenSSL::Digest::SHA256.new)
    [cert, key]
  end

  def subject(domains)
    OpenSSL::X509::Name.parse("/C=IT/L=Temporary self-signed certificate/O=Temporary self-signed certificate/CN=%s" % domains.first)
  end
end