#
# Bender-NG
#
# A toolkit to implement a persistent world in RPGs and online games
# Copyright (C) 2007  Windmill Media
# Copyright (c) 2006-2007 Lele Forzani <lele@windmill.it>
#
#
# = utilities.rb
#
# <short descr>
#
# Author:: Lele Forzani <lele@windmill.it>
# Documentation::  Lele Forzani <lele@windmill.it>
# License::
#   This is NOT free software. License for using this software is granted
#   by written permission from Lele Forzani <lele@windmill.it>
# Revision:: $Id: Utilities.rb 698 2007-03-14 16:32:06Z lele $
#
#
# == Description
#
# Small utilities thrown in the Object Namespace and used elsewhere
#
# == Annotations
#
#
# == Todo

require 'fileutils'


public
def belongs_to(categories)
	categories.find { |e| e == self.to_s.to_sym }
end


#
# Return the class object named <string>
#
def str2class(string)
	return string.split("::").inject(Object) {|x,y| x.const_get(y) }
end

def Dir.mkdir_p(dirname, permissions, prefix = nil)
	dirname = prefix + File.expand_path(dirname) if prefix

	# does not check '/'... it's too abnormal case
	dirs = File.expand_path(dirname).split(%r<(?=/)>)
	if /\A[a-z]:\z/i =~ dirs[0]
		disk = dirs.shift
		dirs[0] = disk + dirs[0]
	end
	dirs.each_index do |idx|
		path = dirs[0..idx].join('')
		Dir.mkdir path unless File.directory?(path)
    end
end

# $URL: https://svn.intercom.it/svn/intercom/projects/Bender-NG/lib/tools/Utilities.rb $
# $Rev: 698 $
# $Author: lele $
# $Date: 2007-03-14 17:32:06 +0100 (Wed, 14 Mar 2007) $
# $Id: Utilities.rb 698 2007-03-14 16:32:06Z lele $
